﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Input;
using XamDataGridDoubleClickCommand.Core;
using System.Collections.ObjectModel;
using System.Windows;

namespace XamDataGridDoubleClickCommand
{
    public class MainViewModel : INotifyPropertyChanged
    {
        public ICommand DoubleClickCommand { get; set; }

        public ObservableCollection<Person> People { get; set; }

        public MainViewModel()
        {
            DoubleClickCommand = new DelegateCommand(ExecuteClick);

            People = new ObservableCollection<Person>();

            for (int x = 0; x < 10; x++)
            {
                People.Add(new Person(String.Format("First {0}", x), String.Format("Last {0}", x)) );
            }
        }

        private void ExecuteClick(object parameter)
        {
            var person = parameter as Person;
            
            if (person == null)
                return;

            MessageBox.Show(String.Format("You double clicked on {0} {1}", person.FirstName, person.LastName));
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void NotifyPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
